/* hybserv2anope
 * Ver.   : 0.0.1
 * Author : gynvael.coldwind//vx
 * Date   : Fri Jul 16 13:18:48 2004
 * WWW    : http://vexillium.org
 * E-Mail : gynvael@lunarii.org
 * Desc.  : hybserv nick&chan database to anope nick&chan database converter
 * Licence for encrypt.*: see these files for info on copyright 
 * Licence for hybserv2anope.c
   
   Permission is hereby granted to use, copy, modify, and distribute this
source code, or portions hereof, for any purpose, without fee, subject
to the following restrictions:

1. The origin of this source code must not be misrepresented.

2. Altered versions must be plainly marked as such and must not
   be misrepresented as being the original source.

3. This Copyright notice may not be removed or altered from any
   source or altered source distribution. 

The author does not take any responsibility for any damage caused by 
this application.
The author does not guarantee that this application is bugfree.
Use at own risk.
 */
 
#include<stdio.h>
#include<string.h>
#include<strings.h>
#include<stdlib.h>
#include<time.h>
#include<netinet/in.h> /* htons only */
#include"encrypt.h" /* MD5 from anope (see ANOPE_COPYING for details) */

const char 
  *hybserv_nick_db_name,
  *hybserv_chan_db_name,
  *anope_nick_db_name,
  *anope_chan_db_name;

/* nickname hashlist struct */
typedef struct nick_node_st 
{
  char nick[ 32 ];
  char email[ 128 ];
  char pass[ 16 ];
  unsigned short len_email, len_nick;
  unsigned short chancount;
  struct nick_node_st *next;
} nick_node_t, *pnick_node_t;

typedef struct chan_node_st
{
  char name[ 256 ];
  char email[ 128 ];
  char founder[ 32 ];
  char pass[ 16 ];
  unsigned short len_email, len_founder;
  struct chan_node_st *next;
} chan_node_t, *pchan_node_t;

#define HASH(nick)  ((tolower((nick)[0])&31)<<5 | (tolower((nick)[1])&31))
pnick_node_t nicks[ 1024 ];
pchan_node_t chans[ 256 ];

/* declarations */
int evil_warning( void );
int converts( void );

/* main */
int
main( int argc, char **argv )
{
  printf( "hybserv2anope database converter v.0.0.1\n"
          " by gynvael.coldwind//vx (http://vexillium.org)\n\n"
          " WARNING: USE THIS SOFTWARE AT YOUR OWN RISK!\n\n" );

  /* check args */
  if( argc != 5 )
  {
    printf( "usage: %s hybserv_nick.db hybserv_chan.db anope_nick.db anope_chan.db\n"
            "\thybserv_nick.db - hybserv nick database (INPUT, READ ONLY)\n"
            "\thybserv_chan.db - hybserv chan database (INPUT, READ ONLY)\n"
            "\tanope_nick.db   - anope nick database (OUTPUT, WILL BE REMOVED IF EXISTS!)\n"
            "\tanope_chan.db   - anope chan database (OUTPUT, WILL BE REMOVED IF EXISTS!)\n\n",
            *argv );
    return 0;
  }

  /* setup file names */
  hybserv_nick_db_name = argv[ 1 ];
  hybserv_chan_db_name = argv[ 2 ];
  anope_nick_db_name = argv[ 3 ];
  anope_chan_db_name = argv[ 4 ];

  /* print out warning */
  if( evil_warning( ) != 0 )
    return 0;

  /* convert */
  if( converts( ) != 0 )
  {
    fprintf( stderr, "ERROR!\n" );
    return 1;
  }

  /* convert chans */
  
  return 0;
}

/* functions */
int 
evil_warning( void )
{
  char answer[ 10 ];
  
  printf( " WARNING: files %s and %s will be removed if exist!\n"
          "          type YES (with capital letters!) if you want to continue: ",
          anope_nick_db_name, anope_chan_db_name );

  /* get answer */
  fgets( answer, 10, stdin );
  puts( " As u wish ;>\n" );
  if( strcmp( answer, "YES\n" ) != 0 )
    return 1;

  return 0;
}

unsigned char tolower( char ch )
{
  if( ch >= 'A' || ch <= 'Z' ) return ch | 0x20;
  return ch;
}

/* simple pass gen */
void generate_pass( char *pass )
{
  int i;
  const char letterz[ ] = 
    "qwertyuiopasdfghjklzxcvbnm1234567890QWERTYUIOPASDFGHJKLZXCVBNM";
  
  for( i = 0; i < 10 + ( rand( ) % 3 ); i++ )
    *pass++ = letterz[ rand( ) % ( sizeof( letterz ) - 1 ) ];

  *pass = '\0';  
}

/* functions */
int strcmp_till_blank( const char *a, const char *b )
{
  while( *a == *b )
  {
    /* hit blank ? */
    if( *a == ' ' ) return 0;

    /* next */
    a++; b++;
  }
  return 1;
}

int strcpy_till_blank( char *a, const char *b )
{
  /* while not blank */
  while( *b && *b != ' ' && *b != '\n' && *b != '\r' && *b != '\n' )
    *a++ = *b++;
  *a = '\0';
  return 0;
}

void inc_channelcount( const char *fndr )
{
  unsigned int hash;
  pnick_node_t itr;
  
  hash = HASH( fndr );
  for( itr = nicks[ hash ]; itr; itr = itr->next )
  {
    /* found ? */
    if( strcasecmp( itr->nick, fndr ) == 0 )
    {
      itr->chancount++;
      return;
    }
  }
}

int load_hybserv_chan_db( FILE *f )
{
  pchan_node_t nchan;
  int state = 0;
  char line[ 512 ];
  unsigned int hash;

  /* rand rand ;> */
  srand( time( NULL ) );

  /* start parsing */
  while( !feof( f ) )
  {
    /* get line */
    fgets( line, 512, f );

    /* comment ? */
    if( line[ 0 ] == ';' ) continue;

    /* analizing any chan? */
    if( state == 1 )
    {
      /* still chan data ? */
      if( line[ 0 ] != '-' || line[ 1 ] != '>' )
      {
        state = 0;
        goto out_of_chan;
      }

      /* analize */
      if( strcmp_till_blank( "EMAIL ", &line[ 2 ] ) == 0 )
      {
        /* copy */
        /* strlen( "->EMAIL " ) == 8 */
        strcpy_till_blank( nchan->email, &line[ 8 ] );
        nchan->len_email = strlen( nchan->email ) + 1; /* +1 for \0 */
      }
      else if( strcmp_till_blank( "FNDR ", &line[ 2 ] ) == 0 )
      {
        /* copy */
        /* strlen( "->FNDR " ) == 7 */
        strcpy_till_blank( nchan->founder , &line[ 7 ] );
        nchan->len_founder = strlen( nchan->founder ) + 1;

        /* inc channelcount */
        inc_channelcount( nchan->founder );
      }
      
      /* next... */
      continue;
    }
    
out_of_chan:
    /* new chan ? */
    state = 1;

    /* alloc struct */
    nchan = (pchan_node_t)malloc( sizeof( chan_node_t ) );
    if( nchan == NULL ) 
      return 1;
    memset( nchan, 0, sizeof( chan_node_t ) );

    /* getchan name */
    strcpy_till_blank( nchan->name, line );

    /* gen password */
    generate_pass( nchan->pass ); 

    /* calc hash */
    hash = tolower( nchan->name[ 1 ] );

    /* add to list */
    nchan->next = chans[ hash ];
    chans[ hash ] = nchan;
  }

  return 0;
}

int write_chan_pass( FILE *f )
{
  int i;
  pchan_node_t itr;

  for( i = 0; i < 256; i++ )
    for( itr = chans[ i ]; itr; itr = itr->next )
    {
      fprintf( f, "%-20s %-24s %-14s %s\n",
          itr->name, itr->founder, itr->pass, itr->email );
    }
  
  return 0; 
}
  
int write_chan_names( FILE *f )
{
  pchan_node_t itr;
  int i;
  unsigned short tmp;
  unsigned short tmp32 = htonl( time( NULL ) );
  char blank[ 64 ];
  char passbuf[ 32 ];
  unsigned short ca_size = htons( 36 );

  /* flags */
  unsigned char flags[4] = { 0, 0, 0xB9, 0x20 };
  /* set flags:
   * last byte
   * 0x20 CI_PEACE 
   * third byte
   * 0x01 CI_ENCRYPTEDPW
   * 0x08 CI_OPNOTICE
   * 0x10 CI_SECUREFOUNDER
   * 0x20 CI_SIGNKICK
   * 0x80 CI_XOP
   */
  
  /* acclevels *
   * don't ask me what is what here, decode it yourself ;>
   * in services.h seek "Indices for cmd_access[]:",
   * the data below are values of access levels for each thing
   * one value = 2 bytes written in big endian
   */
  unsigned char acclvl[ 72 ] = {
    0, 5, 0, 0xA, 0xD8, 0xF0, 0, 5, 0, 5, 0xff, 0xff, 0, 3, 0, 5,
    0, 1, 0xD8, 0xF0, 0xff, 0xfe, 0, 0xA, 0, 0xA, 0xD8, 0xF0, 0, 0xA, 0, 1,
    0, 3, 0, 5, 0, 5, 0, 3, 0, 5, 0, 5, 0, 4, 0, 0xA,
    0, 5, 0, 4, 0, 5, 0, 0xA, 0xD8, 0xF0, 0, 5, 0, 5, 0xD8, 0xF0,
    0, 5, 0, 6, 0xd8, 0xf0, 0xd8, 0xf0
  };

  /* clear */
  memset( blank, 0, 64 );
  memset( passbuf, 0, 32 );
  
  /* write it! */
  for( i = 0; i < 256; i++ )
  {
    for( itr = chans[ i ]; itr; itr = itr->next )
    {
      /* '01' */
      fputc( '\01', f );

      /* write chan name */
      fwrite( itr->name, 1, 64 ,f ); /* CHANMAX = 64 */

      /* write owner */
      tmp = htons( itr->len_founder );
      fwrite( &tmp, 2, 1, f );
      fwrite( itr->founder, 1, itr->len_founder, f );

      /* blank... */
      fwrite( blank, 1, 2, f );

      /* pass */
      encrypt( itr->pass, strlen( itr->pass ), passbuf, 32 ); /* md5 */
      fwrite( passbuf, 1, 32, f );

      /* blank... */
      fwrite( blank, 1, 2, f );

      /* mail */
      tmp = htons( itr->len_email );
      fwrite( &tmp, 2, 1, f );
      fwrite( itr->email, 1, itr->len_email, f );

      /* blank... */
      fwrite( blank, 1, 2, f );
      
      /* times */
      fwrite( &tmp32, 4, 1, f );
      fwrite( &tmp32, 4, 1, f );

      /* blank */
      fwrite( blank, 1, 38, f );

      /* flags */
      fwrite( flags, 1, 4, f );

      /* blank... */
      fwrite( blank, 1, 4, f );

      /* bantype ?!?! */
      fwrite( "\0\x2", 1, 2, f );

      /* CA */
      fwrite( &ca_size, 2, 1, f );

      /* acclvl */
      fwrite( acclvl, 1, 72, f );

      /* blank */
      fwrite( blank, 1, 4, f );

      /* mlock */
      fwrite( "\0\0\0\x24", 1, 4, f ); /* +tn */

      /* blank */
      fwrite( blank, 1, 16, f );

      /* memo max */
      fwrite( "\0\x14", 1, 2, f );

      /* blank */
      fwrite( blank, 1, 8, f );

      /* ttb size */
      fwrite( "\0\x8", 1, 2, f );

      /* blank */
      fwrite( blank, 1, 28,f );     
      
    }

    /* additional blank */
    fputc( '\0', f );
  }
  
  
  return 0;
}

int load_hybserv_nick_db( FILE *f )
{
  pnick_node_t nnick;
  int state = 0;
  char line[ 512 ];
  unsigned int hash;

  /* rand rand ;> */
  srand( time( NULL ) );

  /* start parsing */
  while( !feof( f ) )
  {
    /* get line */
    fgets( line, 512, f );

    /* comment ? */
    if( line[ 0 ] == ';' ) continue;

    /* analizing any nick? */
    if( state == 1 )
    {
      /* still nick data ? */
      if( line[ 0 ] != '-' || line[ 1 ] != '>' )
      {
        state = 0;
        goto out_of_nick;
      }

      /* analize */
      if( strcmp_till_blank( "EMAIL ", &line[ 2 ] ) == 0 )
      {
        /* copy */
        /* strlen( "->EMAIL " ) == 8 */
        strcpy_till_blank( nnick->email, &line[ 8 ] );
        nnick->len_email = strlen( nnick->email ) + 1; /* +1 for \0 */
      }
      
      /* next... */
      continue;
    }
    
out_of_nick:
    /* new nick ? */
    state = 1;

    /* alloc struct */
    nnick = (pnick_node_t)malloc( sizeof( nick_node_t ) );
    if( nnick == NULL ) 
      return 1;
    memset( nnick, 0, sizeof( nick_node_t ) );

    /* getnick name */
    strcpy_till_blank( nnick->nick, line );
    nnick->len_nick = strlen( nnick->nick ) + 1; /* +1 for \0 */

    /* gen password */
    generate_pass( nnick->pass ); 

    /* calc hash */
    hash = HASH( nnick->nick );

    /* add to list */
    nnick->next = nicks[ hash ];
    nicks[ hash ] = nnick;
  }

  return 0;
}

int write_nick_pass( FILE *f )
{
  int i;
  pnick_node_t itr;

  for( i = 0; i < 1024; i++ )
    for( itr = nicks[ i ]; itr; itr = itr->next )
    {
      fprintf( f, "%-24s %-14s %s\n",
          itr->nick, itr->pass, itr->email );
    }

  return 0;
}

int write_nick_groups( FILE *f )
{
  pnick_node_t itr;
  int i;
  char blankspc[ 32 ];
  unsigned short tmp;
  unsigned int tmp32 = htonl( time( NULL ) );

  /* clear */
  memset( blankspc, 0, 32 );

  /* write it! */
  for( i = 0; i < 1024; i++ )
  {
    /* write 0 if no names */
    if( nicks[ i ] == NULL )
    {
      fputc( '\0', f );
      continue;
    }
    
    /* else, write nicks */
    for( itr = nicks[ i ]; itr; itr = itr->next )
    {
      fputc( '\x1', f ); /* 01 */

      /* nick */
      tmp = htons( itr->len_nick );
      fwrite( &tmp, 2, 1, f );
      fwrite( itr->nick, 1, itr->len_nick, f );

      /* blank space */
      fwrite( blankspc, 1, 6, f );

      /* time */
      fwrite( &tmp32, 4, 1, f );
      fwrite( &tmp32, 4, 1, f );

      /* blank space */
      fwrite( blankspc, 1, 2, f );

      /* nick */
      tmp = htons( itr->len_nick );
      fwrite( &tmp, 2, 1, f );
      fwrite( itr->nick, 1, itr->len_nick, f );
      
    }
    /* end, blank */
    fputc( '\0', f ); /* 00 */
  }

  return 0;
}

int write_nick_names( FILE *f )
{
  char passbuf[ 32 ];
  unsigned short passbuf_len = htons(17); /* const for md5 */
  pnick_node_t itr;
  int i;
  char blankspc[ 32 ];
  unsigned short maxsth = htons(0x14);
  unsigned short tmp;
   
  /* nickname flags */
  unsigned char flags[ 4 ] = { 0, 0, 0x40, 0x32 }; /* BIG ENDIAN! */
  /* flags have these values set (from anope's services.h):
   * last byte:
   * 0x02 NI_SECURE
   * 0x10 NI_MEMO_SIGNON
   * 0x20 NI_MEMO_RECEIVE
   * third byte:
   * 0x40 NI_ENCRYPTEDPW
   */ 

  /* clear */
  memset( passbuf, 0, 32 );
  memset( blankspc, 0, 32 );
  
  /* write it! */
  for( i = 0; i < 1024; i++ )
  {
    /* else, write nicks */
    for( itr = nicks[ i ]; itr; itr = itr->next )
    {
      fputc( '\x1', f ); /* 01 */

      /* nick */
      tmp = htons( itr->len_nick );
      fwrite( &tmp, 2, 1, f );
      fwrite( itr->nick, 1, itr->len_nick, f );

      /* pass */
      encrypt( itr->pass, strlen( itr->pass ), passbuf, 32 ); /* md5 */
      fwrite( &passbuf_len, 2, 1, f );
      fwrite( passbuf, 1, 17, f );

      /* email */
      tmp = htons( itr->len_email );
      fwrite( &tmp, 2, 1, f );
      if( itr->len_email ) /* any mail given ? */
        fwrite( itr->email, 1, itr->len_email, f );

      /* blank space */
      fwrite( blankspc, 1, 8, f );

      /* flags */
      fwrite( flags, 1, 4, f );

      /* blank space */
      fwrite( blankspc, 1, 6, f );

      /* max memo */
      fwrite( &maxsth, 2, 1, f );

      /* channel count */
      tmp = htons( itr->chancount );
      fwrite( &tmp, 2, 1, f );
      fwrite( &maxsth, 2 ,1, f );

    }
    /* end, blank */
    fputc( '\0', f ); /* 00 */
  }
        
  return 0;
}

int nick_clean_up( void )
{
  pnick_node_t itrA, itrB;
  int i;

  /* cleanup */
  for( i = 0; i < 1024; i++ )
    for( itrA = nicks[ i ]; itrA; )
    {
      itrB = itrA;
      itrA = itrA->next;
      free( itrB );
    }
  
  return 0;
}

int chan_clean_up( void )
{
  pchan_node_t itrA, itrB;
  int i;

  /* cleanup */
  for( i = 0; i < 256; i++ )
    for( itrA = chans[ i ]; itrA; )
    {
      itrB = itrA;
      itrA = itrA->next;
      free( itrB );
    }
  
  return 0;
}


/* convert nicks */
int 
converts( void )
{
  FILE *in = NULL, *out = NULL, *pass = NULL,
       *chin = NULL, *chout = NULL, *chpass = NULL;

  /* open file */
  printf( " Opening hybserv nickname database...    " );
  if( ( in = fopen( hybserv_nick_db_name, "r" ) ) == NULL )
    goto err;
  puts( "OK!" );
  
  /* load old nicks */
  printf( " Loading hybserv nickname database...    " );
  if( load_hybserv_nick_db( in ) != 0 )
    goto err;
  puts( "OK!" );

  /* open chan file */
  printf( " Opening hybserv channels database...    " );
  if( ( chin = fopen( hybserv_chan_db_name, "r" ) ) == NULL )
    goto err;
  puts( "OK!" );

  /* load old chans */
  printf( " Loading hybserv channels database...    " );
  if( load_hybserv_chan_db( chin ) != 0 )
    goto err;
  puts( "OK!" );
  
  /* create new database */
  printf( " Creating anope nickname database...     " );
  if( ( out = fopen( anope_nick_db_name, "w" ) ) == NULL )
    goto err;
  if( fwrite( "\0\0\0\xD", 1, 4, out ) != 4 )
    goto err;
  puts( "OK!" );

  /* write new nicks */
  printf( " Writting nicknames to anope database... " );
  if( write_nick_names( out ) != 0 )
    goto err;
  puts( "OK!" );
  
  /* write new groups */
  printf( " Writting groups to anope database...    " );
  if( write_nick_groups( out ) != 0 )
    goto err;
  puts( "OK!" );

  /* create new database */
  printf( " Creating anope channel database...      " );
  if( ( chout = fopen( anope_chan_db_name, "w" ) ) == NULL )
    goto err;
  if( fwrite( "\0\0\0\x10", 1, 4, chout ) != 4 )
    goto err;
  puts( "OK!" );
  
  /* write new channels */
  printf( " Writting channels to anope database...  " );
  if( write_chan_names( chout ) != 0 )
    goto err;
  puts( "OK!" );  

  /* creating pass file */
  printf( " Creating nick email/password file...    " );
  if( ( pass = fopen( "nickpass", "w" ) ) == NULL )
    goto err;
  puts( "OK!" );

  /* write emails/passwords */
  printf( " Writting nick emails/passwords...       " );
  if( write_nick_pass( pass ) != 0 )
    goto err;
  puts( "OK!" );

  /* creating chpass file */
  printf( " Creating chan email/password file...    " );
  if( ( chpass = fopen( "chanpass", "w" ) ) == NULL )
    goto err;
  puts( "OK!" );

  /* write emails/passwords */
  printf( " Writting chan emails/passwords...       " );
  if( write_chan_pass( chpass ) != 0 )
    goto err;
  puts( "OK!" );

  /* finish */
  printf( " Finishing conversion...                 " );
  fclose( chin );
  fclose( chout );
  fclose( chpass );
  fclose( in );
  fclose( out );
  fclose( pass );
  
  nick_clean_up( );
  chan_clean_up( );
  puts( "OK!" );


  /* done */
  puts( " DONE!\n" );
  
  

  return 0;
  
err:
  puts( "ERR" );
  if( in ) fclose( in );
  if( out ) fclose( out );
  if( pass ) fclose( pass );
  if( chin ) fclose( chin );
  if( chout ) fclose( chout );
  if( chpass ) fclose( chpass );
  return 1;  
}

